/* $Workfile: OsaLinuxAsp.h $   $Revision: 2 $    $Modtime: 11/15/07 3:52p $  */
/*******************************************************************************

  Odin TeleSystems Inc.

  OTX Telecom Adapter Driver

  @doc internal

  @module

  @normal Copyright (C) Odin TeleSystems Inc., 2007, All Rights Reserved

*******************************************************************************/

#ifndef OSA_LINUX_ASP_H
#define OSA_LINUX_ASP_H

#ifdef DAVINCI


#ifdef __cplusplus
extern "C" {
#else
#endif

#define OSA_ASP_BUF_SIZE 4096


typedef struct {
  OsaUint32 devasp_overruns;
  OsaUint32 devasp_underruns;
  OsaUint32 devasp_dma_acnt;
  OsaUint32 devasp_rsyncerr;
  OsaUint32 devasp_wsyncerr;
} OsaAspStatusS;

typedef enum OsaAspBufFillCntE
{
  OSA_ASP_BYTE_CNT = 1,
  OSA_ASP_WORD_CNT
} OsaAspBufFillCntE;

extern int OsaLinuxAspInitDevAsp(void);

extern int  OsaLinuxAspOpen(void);

extern void OsaLinuxAspClose(void);
 
extern ssize_t OsaLinuxAspWrite(const char *buffer, size_t count);
 
extern ssize_t OsaLinuxAspRead(char *buffer, size_t count);

extern void OsaLinuxAspGetStatus(OsaAspStatusS *status, OsaBool32 resetStatus);

extern void OsaLinuxAspFillOutBufValue(OsaUint8 value);

extern void OsaLinuxAspFillOutBufCount(OsaAspBufFillCntE type);

#ifdef __cplusplus
}
#endif

#endif // DAVINCI code only

#endif  // OSA_LINUX_ASP_H

